import sys

MOD = 10**9 + 7

def main():
    input = sys.stdin.read
    data = input().split()
    
    N = int(data[0])
    values = list(map(int, data[1:]))
    
    ord_list = []
    for i in range(N):
        for j in range(N):
            v = values[i * N + j]
            ord_list.append((v, (i, j)))
    
    ord_list.sort()
    ans = 0
    prefr = [[(0, 0)] for _ in range(N)]
    prefc = [[(0, 0)] for _ in range(N)]

    for v, (x, y) in ord_list:
        pr, pc = prefr[x], prefc[y]
        k = len(pr) - (2 if pr[-1][0] == v else 1)
        l = len(pc) - (2 if pc[-1][0] == v else 1)

        cur = 1 + pr[k][1] + pc[l][1]
        ans = (ans + cur) % MOD

        k += 1
        if k == len(pr):
            pr.append((v, (pr[-1][1] + cur) % MOD))
        else:
            val = (pr[k][1] + cur) % MOD
            pr[k] = (v, val)
        
        l += 1
        if l == len(pc):
            pc.append((v, (pc[-1][1] + cur) % MOD))
        else:
            val = (pc[l][1] + cur) % MOD
            pc[l] = (v, val)
    
    print(ans)

if __name__ == "__main__":
    main()
