def solve():
    N = int(input())
    adj = [list() for _ in range(N + 1)]
    for _ in range(1, N):
        u, v = map(int, input().split())
        adj[u].append(v)
        adj[v].append(u)
    
    ans = list()
    def dfs(u, p, e):
        if e % 2 > 0:
            ans.append(u)
            for v in adj[u]:
                if v != p:
                    dfs(v, u, e + 1)
        else:
            for v in adj[u]:
                if v != p:
                    dfs(v, u, e + 1)
            ans.append(u)
    
    dfs(1, 0, 0)
    print(*ans)

for _ in range(int(input())):
    solve()
